<%
    ' Create various objects we will need
    Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
    Set Sleeper = Server.CreateObject("newObjects.utilctls.COMSleeper")
    
    Dim oThread
    If Not IsObject(Application("HTTPThread")) Then
        Set Application("HTTPThread") = Server.CreateObject("newObjects.utilctls.COMScriptThread")
        Set oThread = Application("HTTPThread")
        Set Context = oThread.Value
        Application("HTTPThread").MultiThreaded = True
        Application("HTTPThread").AddCreator = True
        Application("HTTPThread").Priority = -2
        
        ' By default the shared variables of the thread which are accessible as
        ' oThread.Value(x) from outside and as Context(x) from within the thread are configured
        ' to refuse any object values. We disable this to make possible to pass a log stream and
        ' to allow the thread publish its listening socket so that the controler page (this one)
        ' can interrupt it.
        
        Context.extractValues = False
        
        Context.Add "Log", sf.CreateMemoryStream    ' We will pass this stream to the server thread
                                                    ' it will use it to log the activity
    Else
        Set oThread = Application("HTTPThread")
        Set Context = oThread.Value
    End If
    
    
    If Request("Start").Count > 0 Then
        If oThread.Active Then
            message = "The WEB server thread is already active."
        Else
            Set file = sf.OpenFile(Server.MapPath("http-srv-imp.vbs"),&H40)
            scriptText = file.ReadText(-2)
            
            Context("Address") = CStr(Request("Listen"))
            oThread.Value("Port") = CLng(Request("Port"))
            oThread.Value("Command") = ""
            oThread.Value("Path") = Server.MapPath("httproot")
            
            If Not oThread.Start("VBScript",scriptText) Then
                message = "Error: " & oThread.LastError
            Else
                ' Successfuly started
                mesage = "WEB server successfuly started."
                Sleeper.Sleep(1000)
            End If
        End If
    ElseIf Request("Stop").Count > 0 Then
        If oThread.Active Then
            If oThread.Busy Then
                Context("Command") = "S"
                Context("Listener").Close
                Timeout = 30000
                Do
                    Sleeper.Sleep(1000)
                    Timeout = Timeout - 1000
                    If Timeout < 0 Then
                        message = "Thread does not respond for 30 seconds - terminating it."
                        oThread.Stop
                    End If
                Loop While oThread.Busy
            Else
                ' There could be an error in the WEB server script.
                ' We can only stop it in this situation.
                oThread.Stop
            End If
        End If
    End If
    
    
    

%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>WEB server</title>
</head>

<body>

<B><%= message %></B>

<% If oThread.Active Then 
    If oThread.Busy Then
        %>
        <P>The WEB server is active and responds on <%= Context("Address") %>:<%= Context("Port") %></P>
        <%
    Else
        %>
        <P>The WEB server is loaded but not running perhaps because of an internal error.</P>
        <P>Last reported error is: <%= oThread.lastError %></P>
        <%
    End If
    %>
        <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
            <INPUT TYPE="SUBMIT" VALUE="Stop the WEB server" NAME="Stop">
        </FORM>
        <A HREF="<%= Request.ServerVariables("SCRIPT_NAME") %>">Check server status</A>
        <H4>Last logged activity</H4>
        <% Context("Log").Pos = 0 %>
        <PRE><%= Context("Log").ReadText(-2) %></PRE>
    <%
Else %>
<H4>The WEB server is not active</H4>
<FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
    Start the WEB server on:
    <INPUT TYPE="TEXT" NAME="Listen" VALUE="0.0.0.0" SIZE="16">
    <INPUT TYPE="TEXT" NAME="Port" VALUE="80" SIZE="2">
    <INPUT TYPE="SUBMIT" VALUE="Start" NAME="Start">
</FORM>
<p>The WEB server will serve the static files from the <B>httproot</B> directory only!</P>
<H4>Last logged activity</H4>
<% Context("Log").Pos = 0 %>
<PRE><%= Context("Log").ReadText(-2) %></PRE>

<% End If %>

</body>
</html>
